const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const inventory_movements = sequelize.define(
    'inventory_movements',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

movement_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"purchase",


"usage",


"adjustment",


"transfer_in",


"transfer_out",


"return"

        ],

      },

quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

moved_at: {
        type: DataTypes.DATE,
      
      

      },

reference: {
        type: DataTypes.TEXT,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  inventory_movements.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
































//end loop



    db.inventory_movements.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.inventory_movements.belongsTo(db.inventory_items, {
      as: 'inventory_item',
      foreignKey: {
        name: 'inventory_itemId',
      },
      constraints: false,
    });

    db.inventory_movements.belongsTo(db.batches, {
      as: 'batch',
      foreignKey: {
        name: 'batchId',
      },
      constraints: false,
    });

    db.inventory_movements.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.inventory_movements.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.inventory_movements.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return inventory_movements;
};


